// AvailHandler.cpp: implementation of the AvailHandler class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "mfc.h"
#include "AvailList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include "AvailList.h"
#include "Except.h"
#include "Hash.h"
#include <iostream>

FREEITER AvailHandler::getIter( int i)
{
	FREEITER temp = availlist.begin();

	for ( int j = 0 ; j < i; j++)
		temp++;

	return temp;
}

void AvailHandler::sort()
{
	FREEITER it;
	int NUM = availlist.size();

	// Sorting by bubble sort !!!

	for ( int i =  NUM - 1; i > 0; i-- )
		for ( int j = 0; j < i; j++ )
			if ( (*getIter(j)).size > (*getIter(j+1)).size )
				std::swap( *getIter(j), *getIter(j+1) );
}

void AvailHandler::loadfromfile()
{
	STRING temp;
	cache->read( type, 0, temp);
	int number, i = 0, size, reference;

	number = Hash::unpackInt( temp, i);
	i += 4;

	for(int count = 0;count < number;count++)
	{
		cache->read( type, i, temp);

		int k = 0;
		size = Hash::unpackInt( temp, k);
		reference = Hash::unpackInt( temp, k);
		i += k;

		availlist.push_back( FreeSpace(size, reference));
	}
}

AvailHandler::AvailHandler( Cache * cache, char type)
{
	this->cache = cache;
	this->type = type;

	loadfromfile();
}

AvailHandler::~AvailHandler()
{
	int size = availlist.size(), i = 0, offset = 0;
	STRING temp;
	temp.resize( 8);

	Hash::packInt( temp, size, i);
	cache->write( type, offset, temp);
	offset += 8;

	FREEITER it = availlist.begin();
	FREEITER ite = availlist.end();

	for(;it != ite;it++)
	{
		i = 0;
		Hash::packInt( temp, it->size, i);
		Hash::packInt( temp, it->reference, i);
		if(offset >= cache->getSize(type))
			cache->write2end( type, temp);
		else
			cache->write( type, offset, temp);
		offset += 8;	
	}
}

FreeSpace AvailHandler::findbest(int size)
{
	if( availlist.empty())
		throw NotFound();

	FreeSpace retval( -1, -1);

	FREEITER begin = availlist.begin();
	FREEITER end = availlist.end();

	for(;begin != end;begin++)
	{
		if(begin->size >= size)
		{
			retval = *begin;
			goto RETURN;
		}
	}
RETURN:
	if(begin->size < size)
		throw NotFound();
		
	if(retval.size != -1) availlist.erase( begin);
	return retval;
}

void AvailHandler::Add(int size, int reference)
{
	if( size>0 )
	{
		availlist.push_back( FreeSpace(size, reference) );	
		sort();
	}
}
