// ache.h: interface for the Cache class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ACHE_H__0797B672_C843_49A9_B646_0AEE1D8FDCDD__INCLUDED_)
#define AFX_ACHE_H__0797B672_C843_49A9_B646_0AEE1D8FDCDD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __CACHE_H_
#define __CACHE_H_

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ INCLUDES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#include <string>
#include <fstream>
#include "direct.h"

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ TYPES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
typedef std::string		STRING;
typedef std::streamoff	OFFSET;

#define BUFNUM			100
#define BUFSIZE					256
#define	BUCKETSIZE	31
#define SPACESIZE	100

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ CLASS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
class Cache
{
public:
	Cache( STRING path, char isnew);
	~Cache();

	int			write2end( char file, STRING mustwrite);
	int			write( char file, OFFSET offset, STRING mustwrite);
	int 		read( char file, OFFSET offset, STRING & mustread);
	void		inform();
	int			getSize( int file) { return size[file]; }
private:
	//Methods
	int			isInMem( char file, OFFSET location);
	int			load( char file, OFFSET location);
	int			getLRU();

	//Fields
	int			lastuse;
	STRING		path;
	std::ofstream		log;	
	std::fstream		files[8];	
	int			size	[8];
	STRING		buf		[BUFNUM];
	OFFSET		offset	[BUFNUM];
	char		type	[BUFNUM];
	int			last	[BUFNUM];
	char		changed	[BUFNUM];
};
#endif

#endif // !defined(AFX_ACHE_H__0797B672_C843_49A9_B646_0AEE1D8FDCDD__INCLUDED_)
