// Manager.cpp: implementation of the Manager class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "mfc.h"
#include "Manager.h"
#include "MainFrm.h"
#include "Choice.h"
#include "InputForm.h"

CString str2mfcstr( STRING what);
CString intstring(long int number);

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

typedef std::list<STRING> STRLIST;

extern STRLIST	mylines;
extern int		horiz;
extern CMainFrame * allpapa;
extern PERSONLIST persons;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include "Manager.h"
#include <iostream>

STRING char2str( const char * input, int count, char delim);

STRING intstringstl(long int number)
{
	if(number <= 0)
		return STRING("0");

	STRING temp;
	int count = 0;

	while(number != 0){
		temp += (number % 10) + '0';
		number /= 10;
	}

	STRING temp2;
	int mybegin = temp.size();

	for(count = mybegin - 1;count >= 0;count--)
		temp2 += temp[count];

	return temp2;
}


Manager::Manager( STRING path, char isnew)
:	cache( path, isnew), hash( &cache, 1), btree1( &cache, 2), 
	btree2( &cache, 3) , avail( &cache , 4) , buffer( &cache, 0, &avail) 
{
	STRING temp = buffer.directread( 0);
	int i=0;
	objectIDcount = Hash::unpackInt(temp,i);

	if(!objectIDcount)
		objectIDcount++;
	
	fterm='|';
	rterm='\n';
}

void Manager::add( Person * p)
{
	try
	{
		p->setObjectID(objectIDcount++);
		int offset = buffer.pack(p->pack(fterm,rterm,0));
		hash.addValue( offset, objectIDcount - 1);
		btree1.add( p->getL_Name(), objectIDcount - 1);
		btree2.add( p->getN_Code(), objectIDcount - 1);
	}
	catch(Except & e)
	{
		allpapa->outputline( e.message);
	}
}

INTLIST & Manager::find( STRING key, char flag)
{
	if( flag == 1)
	{
		btree2.find( key);
		return btree2.lastfounds;
	}
	else
	{
		btree1.find( key);
		return btree1.lastfounds;
	}
}

void Manager::remove( STRING key, char flag, FileHasOpened * thepapa)
{
	try
	{
		INTLIST foundlist = find( key, flag);
		int count = 1, mustdelete = *(foundlist.begin());
		Person person;
		STRING temps;

		if( foundlist.size() != 1)
		{
			INTITER it = foundlist.begin();
			INTITER ite = foundlist.end();

			for(;it != ite;it++)
			{
				person.unpack( buffer.unpack( hash.getValue( *it)), fterm, rterm, 0);

				STRING temp = intstringstl( count);
				temp += ".";
				allpapa->outputline( temp);
				person.tostring();

				count++;
			}

			do
			{
				allpapa->Invalidate( FALSE);
				CClientDC dc (thepapa);
				CChoice Dlg(thepapa);

				if(Dlg.DoModal() == IDOK)
				{
					mustdelete = Dlg.m_choice;
				}
			}while( mustdelete > foundlist.size() || mustdelete <= 0);

			it = foundlist.begin();

			for(count = 1;count < mustdelete;count++)
				it++;

			mustdelete = *it;
		}

		mustdelete = hash.getValue( mustdelete);

		person.unpack( buffer.unpack( mustdelete), fterm, rterm, 0);
		buffer.remove( mustdelete);

		mustdelete = person.getObjectID();
		hash.deleteValue( mustdelete);

		temps = person.getL_Name();
		count = temps.size();
		temps.resize( count + 4);
		Hash::packInt( temps, mustdelete, count);
		btree1.remove( temps);

		temps = person.getN_Code();
		count = temps.size();
		temps.resize( count + 4);
		Hash::packInt( temps, mustdelete, count);
		btree2.remove( temps);
	}
	catch(NotFound & e)
	{
		allpapa->outputline( "The person does not found!!");
	}
}

void Manager::getPersons( STRING key, char flag, PERSONLIST & persons)
{
	try
	{
		INTLIST foundlist = find( key, flag);
		persons.resize( foundlist.size());

		INTITER it = foundlist.begin();
		INTITER ite = foundlist.end();
		PERSONITTER pit = persons.begin();

		for(;it != ite;it++, pit++)
			pit->unpack( buffer.unpack( hash.getValue( *it)), fterm, rterm, 0);
	}
	catch(NotFound & e)
	{
		allpapa->outputline( "The person does not found!!");
	}
}

Manager::~Manager()
{
	int k = 0;
	STRING temp;
	temp.resize(8);
	Hash::packInt(temp,objectIDcount,k);
	buffer.directwrite(temp,0);
}

void Manager::change( STRING key, char flag, FileHasOpened * thepapa)
{
	try
	{
		INTLIST foundlist = find( key, flag);
		int count = 1, mustdelete = *(foundlist.begin());
		Person person;
		STRING temps;

		if( foundlist.size() != 1)
		{
			INTITER it = foundlist.begin();
			INTITER ite = foundlist.end();

			for(;it != ite;it++)
			{
				person.unpack( buffer.unpack( hash.getValue( *it)), fterm, rterm, 0);

				STRING temp = intstringstl( count);
				temp += ".";
				allpapa->outputline( temp);

				person.tostring();

				count++;
			}

			do
			{
				allpapa->Invalidate( FALSE);
				CClientDC dc (thepapa);
				CChoice Dlg(thepapa);

				if(Dlg.DoModal() == IDOK)
				{
					mustdelete = Dlg.m_choice;
				}
			}while( mustdelete > foundlist.size() || mustdelete <= 0);

			it = foundlist.begin();

			for(count = 1;count < mustdelete;count++)
				it++;

			mustdelete = *it;
		}

		mustdelete = hash.getValue( mustdelete);

		person.unpack( buffer.unpack( mustdelete), fterm, rterm, 0);
		buffer.remove( mustdelete);

		mustdelete = person.getObjectID();
		hash.deleteValue( mustdelete);

		temps = person.getL_Name();
		count = temps.size();
		temps.resize( count + 4);
		Hash::packInt( temps, mustdelete, count);
		btree1.remove( temps);

		temps = person.getN_Code();
		count = temps.size();
		temps.resize( count + 4);
		Hash::packInt( temps, mustdelete, count);
		btree2.remove( temps);

		CClientDC dc (thepapa);
		CInputForm Dlg(thepapa, 0);

		persons.resize( 0);
		persons.push_back( person);
/*
		CEdit * in = (CEdit*) ( Dlg.GetDlgItem(1000) );//Dlg.IDC_EDIT_First);

		in->SetWindowText( str2mfcstr( persons.begin()->getF_Name()));

		in = (CEdit*) ( Dlg.GetDlgItem(1001));//Dlg.IDC_EDIT_Last);
		in->SetWindowText( str2mfcstr( persons.begin()->getL_Name()));

		in = (CEdit*) ( Dlg.GetDlgItem(1006));//Dlg.IDC_EDIT_National);
		in->SetWindowText( str2mfcstr( persons.begin()->getN_Code()));

		in = (CEdit*) ( Dlg.GetDlgItem(1007));//Dlg.IDC_EDIT_BirthPlace);
		in->SetWindowText( str2mfcstr( persons.begin()->getB_Place()));

		in = (CEdit*) ( Dlg.GetDlgItem(1008));//Dlg.IDC_EDIT_Mother);
		in->SetWindowText( str2mfcstr( persons.begin()->getMother()));

		in = (CEdit*) ( Dlg.GetDlgItem(1009));//Dlg.IDC_EDIT_Father);
		in->SetWindowText( str2mfcstr( persons.begin()->getFather()));

		in = (CEdit*) ( Dlg.GetDlgItem(1010));//Dlg.IDC_EDIT_Year);
		in->SetWindowText( intstring( persons.begin()->getYear()));

		in = (CEdit*) ( Dlg.GetDlgItem(1011));//Dlg.IDC_EDIT_Mounth);
		in->SetWindowText( intstring( persons.begin()->getMounth()));

		in = (CEdit*) ( Dlg.GetDlgItem(1012));//Dlg.IDC_EDIT_Day);
		in->SetWindowText( intstring( persons.begin()->getDay()));
*/
		Dlg.DoModal();
	
		allpapa->linesflash();
		Person tempp = *(persons.begin());
		add( &tempp);
		persons.resize( 0);
	}
	catch(NotFound & e)
	{
		allpapa->outputline( "The person does not found!!");
	}
}


void Manager::inform()
{
	cache.inform();	
}

void Manager::import( STRING path)
{
	Person p;
	STRING temp;
	char t[300];
	std::ifstream file;
	file.open( path.c_str(), std::ios::binary);
	if(!file.good())
		throw Except("ERROR : Bad Import File Name !!");
	char ch;
	while(!file.eof())
	{
		file.get( t, 300, '\n');
		temp = char2str(t,300,'\n');
		p.unpack(temp,fterm,rterm,1);
		add( &p);
		file.get(ch);
	}
	file.close();	
}





