// Manager.h: interface for the Manager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MANAGER_H__4ACD8AF8_54F5_401F_97B5_4BAAD833B283__INCLUDED_)
#define AFX_MANAGER_H__4ACD8AF8_54F5_401F_97B5_4BAAD833B283__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __MANAGER_H_
#define __MANAGER_H_

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ INCLUDES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#include <string>
#include <fstream>
#include <iostream>
#include <list>
#include "Hash.h"
#include "Cache.h"
#include "AvailList.h"
#include "BTree.h"
#include "Except.h"
#include "Person.h"
#include "FileHasOpened.h"

#include "Buffer.h"

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ TYPES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
typedef std::string					STRING;
typedef std::streamoff				OFFSET;
typedef std::list<int>				INTLIST;
typedef std::list<Person>			PERSONLIST;
typedef std::list<int>::iterator	INTITER;
typedef std::list<Person>::iterator	PERSONITTER;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ CLASS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
class Manager
{
public:
	Manager( STRING path, char isnew);
	~Manager();

	void			add( Person * p);
	void			remove( STRING key, char flag, FileHasOpened * thepapa);
	void			getPersons( STRING key, char flag, PERSONLIST & persons);
	void			import( STRING path);
	void			inform();
	void			change( STRING key, char flag, FileHasOpened * thepapa);
	
private:
	INTLIST &		find( STRING key, char flag);	//Flag = 0 -> L_Name Flag = 1 -> N_Code

	int				objectIDcount;
	Cache			cache;
	Hash			hash;
	BTree			btree1;		//L_Name
	BTree			btree2;		//N_Code
	AvailHandler	avail;
	Buffer			buffer;

	char			fterm, rterm;
};
#endif
#endif // !defined(AFX_MANAGER_H__4ACD8AF8_54F5_401F_97B5_4BAAD833B283__INCLUDED_)
