// Person.h: interface for the Person class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PERSON_H__1FAA4835_ED20_4DB4_A3DF_5CF3071EAFA0__INCLUDED_)
#define AFX_PERSON_H__1FAA4835_ED20_4DB4_A3DF_5CF3071EAFA0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __PERSON_H_
#define __PERSON_H_

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ INCLUDES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#include "Buffer.h"
#include <string>
#include <iostream>

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ TYPES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
typedef std::string		STRING;
typedef std::ostream	OSTREAM;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ CLASS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
class Date
{
	friend class Person;
	friend OSTREAM &	operator<<(OSTREAM & out, const Date & date);
	int		day;
	int		month;
	int		year;
public:
	//Constructors
	
	//Methods
	STRING	pack( char fterm);
	void	unpack( STRING packed, int &index, char fterm);

};

class Person 
{

	friend OSTREAM &	operator<<(OSTREAM & out, const Person & person);

public:
	//Constuctors	

	//Methods 
	STRING		pack( char fterm, char rterm, char flag);
	// flag -> 0 pack to DataBase
	void		unpack( STRING packed, char fterm, char rterm, int flag);
	// ID -> 0 if reading from DataBase ; ID -> ID if reading from inputfile
	void		getFromConsole();
	void		tostring();

	STRING		getF_Name(){return F_Name;}
	STRING		getL_Name(){return L_Name;}
	STRING		getN_Code(){return N_Code;}
	int 		getObjectID(){return ObjectID;}
	char		getGender(){return Gender;}
	STRING		getB_Place(){return B_Place;}
	STRING		getMother(){return Mother;}
	STRING		getFather(){return Father;}

	int			getYear(){return B_Date.year;}
	int			getMounth(){return B_Date.month;}
	int			getDay(){return B_Date.day;}

	void		setObjectID(int ObjectID){this->ObjectID = ObjectID;}
	void		setF_Name( const STRING & what){F_Name = what;}
	void		setL_Name( const STRING & what){L_Name = what;}
	void		setGender( char what){Gender = what;}
	void		setN_Code( const STRING & what){N_Code = what;}
	void		setB_Place( const STRING & what){B_Place = what;}
	void		setMother( const STRING & what){Mother = what;}
	void		setFather( const STRING & what){Father = what;}

	void		setYear( int what){B_Date.year = what;}
	void		setMounth( int what){B_Date.month = what;}
	void		setDay( int what){B_Date.day = what;}

private:
	int			ObjectID;  
	STRING		F_Name;
	STRING		L_Name;
	char		Gender;
	STRING		N_Code;
	Date		B_Date;
	STRING		B_Place;
	STRING		Mother;
	STRING		Father;
};



#endif

#endif // !defined(AFX_PERSON_H__1FAA4835_ED20_4DB4_A3DF_5CF3071EAFA0__INCLUDED_)
